/* Sistemas Integrados TEKNISA
  Controle de Produo

Nome: 3931_CDPSTPO.SQL

Descrio:
Calcula periodicidade de produo para dias da semana.

P_CDFILIAL     - Cdigo da Filial.
P_CDPERIPRODU  - Cdigo da Periodicidade de Produo.
P_DTINICIAL    - Data inicial a ser gerado o clculo.
P_IDDIANUTIL   - Indicador de utilizao de dia no til para produo.
P_DTPROCESSA   - Data de Processamento da Filial.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
03/09/2004 - Fabrcio Marcelo da Silva
*/

CREATE OR REPLACE PROCEDURE PERIPRODUCAO_SEMANAL
   (P_CDFILIAL     IN VARCHAR2,
    P_CDPERIPRODU  IN VARCHAR2,
    P_DTINICIAL    IN DATE,
    P_IDDIANUTIL   IN VARCHAR2,
    P_DTPROCESSA   IN DATE) IS

    V_CONTAUXI    NUMBER; 
    V_DTDIAPRODU  DATE;

/*-- CURSOR QUE CONTEM AS DATAS DE PRODUCAO NO MES COM BASE NOS DIAS DE PRODUCAO SEMANAIS --*/

   CURSOR C_DATAS_PRODU IS
      (SELECT
          NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
       FROM
          DIASPRODUCAO
       WHERE
          CDPERIPRODU = P_CDPERIPRODU AND
          IDOCORP01 = '1'             AND
          NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO)) >= P_DTPROCESSA
       UNION
       SELECT
          NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO))
       FROM
          DIASPRODUCAO
       WHERE
          CDPERIPRODU = P_CDPERIPRODU AND
          IDOCORP02 = '1' AND
          TO_CHAR(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
                  ,TO_NUMBER(DIPRODUCAO)),'MM') = TO_CHAR(P_DTINICIAL,'MM') AND
          (NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
           ,TO_NUMBER(DIPRODUCAO)) >= P_DTPROCESSA)
       UNION
       SELECT
          NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO))
       FROM
          DIASPRODUCAO
       WHERE
          CDPERIPRODU = P_CDPERIPRODU AND
          IDOCORP03 = '1' AND
          TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)),'MM') = TO_CHAR(P_DTINICIAL,'MM') AND
          (NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)) >= P_DTPROCESSA)
       UNION
       SELECT
          NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO))
       FROM
          DIASPRODUCAO
       WHERE
          CDPERIPRODU = P_CDPERIPRODU AND
          IDOCORP04 = '1' AND
          TO_CHAR(NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)),'MM') = TO_CHAR(P_DTINICIAL,'MM') AND
          (NEXT_DAY(NEXT_DAY(NEXT_DAY(NEXT_DAY(LAST_DAY(P_DTINICIAL - 1),TO_NUMBER(DIPRODUCAO))
          ,TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)),TO_NUMBER(DIPRODUCAO)) >= P_DTPROCESSA)
       UNION
       SELECT
          NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIPRODUCAO))
       FROM
          DIASPRODUCAO
       WHERE
          CDPERIPRODU = P_CDPERIPRODU AND
          IDOCORP05 = '1' AND
          TO_CHAR(NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIPRODUCAO)),'MM') = TO_CHAR(P_DTINICIAL,'MM') AND
          (NEXT_DAY(LAST_DAY(P_DTINICIAL)-7,TO_NUMBER(DIPRODUCAO)) >= P_DTPROCESSA)
      ) ORDER BY 1;
BEGIN
   OPEN C_DATAS_PRODU;
   LOOP
      FETCH C_DATAS_PRODU
      INTO V_DTDIAPRODU;
      EXIT WHEN C_DATAS_PRODU%NOTFOUND;

      /* Verifica se o dia e util */
      SELECT
         COUNT(*) INTO V_CONTAUXI
      FROM
         FERICOMP
      WHERE
         CDFILIAL   = P_CDFILIAL    AND
         DTFERICOMP = V_DTDIAPRODU;

      IF ((P_IDDIANUTIL = 'S') AND (V_CONTAUXI = 0)) OR
         (P_IDDIANUTIL = 'N')                        THEN

         /*- INCLUI A DATA DE ENTREGA CALCULADA NO CALENDARIO DE PRODUCAO -*/
         INSERT INTO CALEPRODUCAO
            (CDFILIAL,
             CDPERIPRODU,
             DTPRODUCAO)
         VALUES
            (P_CDFILIAL,
             P_CDPERIPRODU,
             V_DTDIAPRODU);
         COMMIT;
      END IF;
   END LOOP;
   CLOSE C_DATAS_PRODU;
END;
/
