/*
SISTEMA: MANUFATURA
DATA DA CRIAO: INCIO  31 / 05 / 2000
CRIAO: Renata Diniz
OBJETIVO: Gera Ordem de Produo para Subprodutos
*/

If EXISTS(SELECT *
          FROM SYSOBJECTS O,
               SYSUSERS U
          WHERE  o.name = 'INSERE_SUBPRODMAN' and
                 type = 'P'                   and
                 u.uid = o.uid                and
                 u.name = USER)
DROP procedure INSERE_SUBPRODMAN;
GO

CREATE PROCEDURE INSERE_SUBPRODMAN @P_CDFILIAL     VARCHAR(4),
                                   @P_LANCESTQ     VARCHAR(10),
                                   @P_TIPOOPER     VARCHAR(2),
                                   @P_CDPRODUTO    VARCHAR(10),
                                   @P_QTITEMPROD   NUMERIC(15,5),
                                   @P_VRTOTAITEM   NUMERIC(16,2),
                                   @P_VRDESCITEM   NUMERIC(16,2),
                                   @P_VRBRUTITEM   NUMERIC(16,5),
                                   @P_VRCONTITEM   NUMERIC(16,5),
                                   @P_VRTOTALANCTO NUMERIC,
                                   @P_QTDELANCTO   NUMERIC,
                                   @P_TIPOMOVI     VARCHAR(1),
                                   @P_INIVALID     DATETIME,
                                   @P_CDPRODESTO   VARCHAR(10),
                                   @P_NRPEDIDO     VARCHAR(10),
                                   @P_NRITEMPED    VARCHAR(10),
                                   @P_IDTPCOMPPROD VARCHAR(01),
                                   @P_CDALMOXARIFE VARCHAR(06) = ' ',
                                   @P_CDLOCALESTOQ VARCHAR(06) = ' '
AS
   DECLARE @V_CDFILIMOVI   VARCHAR(04);
BEGIN
   SELECT @V_CDFILIMOVI = MAX(CDFILIMOVI)
   FROM LANCTOESTOQ
   WHERE  CDFILIAL   = @P_CDFILIAL AND
          NRLANCESTQ = @P_LANCESTQ;
END;
GO

ALTER PROCEDURE INSERE_SUBPRODMAN @P_CDFILIAL     VARCHAR(4),
                                   @P_LANCESTQ     VARCHAR(10),
                                   @P_TIPOOPER     VARCHAR(2),
                                   @P_CDPRODUTO    VARCHAR(10),
                                   @P_QTITEMPROD   NUMERIC(15,5),
                                   @P_VRTOTAITEM   NUMERIC(16,2),
                                   @P_VRDESCITEM   NUMERIC(16,2),
                                   @P_VRBRUTITEM   NUMERIC(16,5),
                                   @P_VRCONTITEM   NUMERIC(16,5),
                                   @P_VRTOTALANCTO NUMERIC,
                                   @P_QTDELANCTO   NUMERIC,
                                   @P_TIPOMOVI     VARCHAR(1),
                                   @P_INIVALID     DATETIME,
                                   @P_CDPRODESTO   VARCHAR(10),
                                   @P_NRPEDIDO     VARCHAR(10),
                                   @P_NRITEMPED    VARCHAR(10),
                                   @P_IDTPCOMPPROD VARCHAR(01),
                                   @P_CDALMOXARIFE VARCHAR(06) = ' ',
                                   @P_CDLOCALESTOQ VARCHAR(06) = ' '


AS
   DECLARE @V_EXISTE_PRODUTO NUMERIC;
   DECLARE @V_EXISTE_PROD    NUMERIC;
   DECLARE @V_ORDPRODUCAO  VARCHAR(10);
   DECLARE @V_CDREQPROD    VARCHAR(10);
   DECLARE @V_QTESTOQUE    NUMERIC;
   DECLARE @V_NULL         NUMERIC;
   DECLARE @V_QTTOTAL      NUMERIC;
   DECLARE @V_FATOCONV     NUMERIC;
   DECLARE @V_TOTABRUT     NUMERIC;
   DECLARE @V_QTDELANCTO   NUMERIC;
   DECLARE @V_QTDEAUX      NUMERIC;
   DECLARE @V_VRUNITLANCTO NUMERIC;
   DECLARE @V_VRTOTALANCTO NUMERIC;
   DECLARE @V_TOTACONTAB   NUMERIC;
   DECLARE @V_CDPRODESTO   VARCHAR(10);
   DECLARE @V_NRSEQITPROD  NUMERIC;
   DECLARE @V_VRUNITITEM   NUMERIC;

   DECLARE @V_IDUTILALMOX  VARCHAR(01);
   DECLARE @V_IDUTILLCESTQ VARCHAR(01);
   DECLARE @V_IDUTILLOTE   VARCHAR(01);

   DECLARE @V_CDFILIMOVI   VARCHAR(04);
   DECLARE @V_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_CDLOCALESTOQ VARCHAR(06);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(04);

   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_CDSUBPRODUTO VARCHAR(10);
   DECLARE @V_QTSUBPRODROT NUMERIC;

   DECLARE @V_PADRAO       VARCHAR(1);
   DECLARE @V_ROTFABLOC    NUMERIC;
   DECLARE @V_ROTFAB       NUMERIC;
   DECLARE @V_VRCUSTENTR   NUMERIC;
   DECLARE @V_ERRO         VARCHAR(20);
   DECLARE @V_CDLOJA       VARCHAR(10);
   DECLARE @V_IDCUSEXP     VARCHAR(02);
   DECLARE @V_QTDE         NUMERIC;  
   DECLARE @V_QTDEESTO     NUMERIC;
   DECLARE @V_VALRESTO     NUMERIC; 
   DECLARE @V_VALRBRUT     NUMERIC;

BEGIN
   SET @V_IDUTILALMOX    = NULL;
   SET @V_IDUTILLCESTQ   = NULL;
   SET @V_IDUTILLOTE     = NULL;
   SET @V_ROTFAB         = 0;
   SET @V_ROTFABLOC      = 0;
   SET @V_CDPRODUTO      = NULL;
   SET @V_CDSUBPRODUTO   = NULL;
   SET @V_QTSUBPRODROT   = 0;
   
   SET @V_CDALMOXARIFE   = NULL;
   SET @V_CDLOCALESTOQ   = NULL;
   SET @V_EXISTE_PROD    = 0;
   SET @V_FATOCONV       = NULL;
   SET @V_CDPRODESTO     = NULL;
   SET @V_EXISTE_PRODUTO = NULL;
   SET @V_NRSEQITPROD    = NULL;


   SELECT @V_CDFILIMOVI = MAX(CDFILIMOVI)
   FROM LANCTOESTOQ
   WHERE  CDFILIAL   = @P_CDFILIAL AND
          NRLANCESTQ = @P_LANCESTQ;

   SELECT @V_IDUTILALMOX  = ISNULL(MAX(IDUTILALMOX),'N'),
          @V_IDUTILLCESTQ = ISNULL(MAX(IDUTILLCESTQ),'N'),
          @V_IDUTILLOTE   = ISNULL(MAX(IDUTILLOTE),'N')
   FROM PARAMFILIAL
   WHERE CDFILIAL = @V_CDFILIMOVI;


   IF @P_IDTPCOMPPROD = 'F' BEGIN

      SELECT @V_ROTFAB = COUNT(*)
      FROM ROTFABRICA
      WHERE CDPRODUTO = @P_CDPRODUTO;

      SELECT @V_ROTFABLOC = COUNT(*)
      FROM ROTFABLOCAL
      WHERE CDFILIAL  = @V_CDFILIMOVI AND
            CDPRODUTO = @P_CDPRODUTO;

      IF @V_ROTFABLOC = 0
      BEGIN
        SET @V_PADRAO = 'S';
      END
      ELSE BEGIN
         SET @V_PADRAO = 'N';
      END;
   END
   ELSE BEGIN
      IF @P_IDTPCOMPPROD = 'V' BEGIN
         SET @V_PADRAO = 'V';
      END;
   END;


   IF @V_PADRAO = 'S' BEGIN
      DECLARE CUR_ROTFAB CURSOR FOR
         (SELECT
            R.CDPRODUTO, CDSUBPRODUTO, QTSUBPRODROT
          FROM
             ROTFABRICA R, PRODFILI P
          WHERE
             R.CDPRODUTO    =  @P_CDPRODUTO    AND
             P.CDFILIAL     =  @V_CDFILIMOVI   AND
             R.CDSUBPRODUTO =  P.CDPRODUTO     AND
             ISNULL(P.IDCNTRESTOQ, 'S')  =  'S')
   END
   ELSE BEGIN
      IF @V_PADRAO = 'N' BEGIN

         DECLARE CUR_ROTFAB CURSOR FOR
            (SELECT
               R.CDPRODUTO, CDSUBPRODLOC, QTSUBPRODLOC
             FROM
                ROTFABLOCAL R, PRODFILI P
             WHERE
                R.CDFILIAL     = @V_CDFILIMOVI    AND
                R.CDPRODUTO    = @P_CDPRODUTO     AND
                P.CDFILIAL     =  @V_CDFILIMOVI   AND
                R.CDSUBPRODLOC =  P.CDPRODUTO     AND
                ISNULL(P.IDCNTRESTOQ, 'S')  =  'S')
      END
      ELSE BEGIN

         DECLARE CUR_ROTFAB CURSOR FOR
            SELECT C.CDPRODUTO, C.CDPRODCOMPED, SUM(C.QTITCOMPPROD) QTITCOMPPROD
            FROM COMPITEMPED C, PRODFILI P
            WHERE
               C.CDFILIAL    =  @V_CDFILIMOVI AND
               C.NRPEDIDO    =  @P_NRPEDIDO   AND
               C.NRITEMPED   =  @P_NRITEMPED  AND
               C.CDPRODUTO   =  @P_CDPRODUTO  AND
               C.CDFILIAL    =  P.CDFILIAL   AND
               C.CDPRODCOMPED = P.CDPRODUTO  AND
               ISNULL(P.IDCNTRESTOQ, 'S') =  'S'
            GROUP BY C.CDPRODUTO, C.CDPRODCOMPED
            ORDER BY
               C.CDPRODCOMPED

      END;
   END;

   OPEN CUR_ROTFAB;

   FETCH NEXT FROM CUR_ROTFAB INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT
   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF (@V_IDUTILALMOX = 'S') BEGIN
         IF (@P_CDALMOXARIFE IS NULL) BEGIN
            SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
                   @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
            FROM  PRODFILI
            WHERE CDFILIAL  = @V_CDFILIMOVI AND
                  CDPRODUTO = @V_CDSUBPRODUTO;

            IF (@V_CDALMOXARIFE IS NULL) BEGIN
               SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
                      @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
               FROM   PARAMFILIAL
               WHERE  CDFILIAL = @V_CDFILIMOVI;
            END;
         END
         ELSE BEGIN
            IF NOT(@P_CDALMOXARIFE = ' ') BEGIN
               SET @V_CDALMOXARIFE = @P_CDALMOXARIFE;
               SET @V_CDLOCALESTOQ = @P_CDLOCALESTOQ;
            END
            ELSE BEGIN
               SELECT @V_CDLOJA = MAX(CDLOJA)
               FROM ITEMVENDA IV, LANCTOESTOQ L
               WHERE IV.CDPRODUTO   = @V_CDPRODUTO    AND
                     IV.NRLANCTONF  = L.NRLANCTONF   AND
                     IV.CDFILIALNF  = L.CDFILIAL     AND
                     L.NRLANCESTQ   = @P_LANCESTQ     AND
                     L.CDFILIAL     = @P_CDFILIAL;

               SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
                      @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
               FROM LOJA
               WHERE CDLOJA = @V_CDLOJA;

               IF (@V_CDALMOXARIFE IS NULL) BEGIN

                  SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
                         @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
                  FROM PRODFILI PF, PRODUTO P
                  WHERE PF.CDFILIAL  = @V_CDFILIMOVI  AND
                        PF.CDPRODUTO = P.CDPRODESTO  AND
                        P.CDPRODUTO  = @V_CDSUBPRODUTO;
                  IF (@V_CDALMOXARIFE IS NULL) BEGIN
                     SELECT @V_CDALMOXARIFE = MAX(CDALMOXARIFE),
                            @V_CDLOCALESTOQ = MAX(CDLOCALESTOQ)
                     FROM   PARAMFILIAL
                     WHERE  CDFILIAL = @V_CDFILIMOVI;
                  END;
               END;
            END;
         END;
      END
      ELSE BEGIN
         SET @V_CDALMOXARIFE = ' ';
         SET @V_CDLOCALESTOQ = ' ';

      END;

      IF (@V_IDUTILLCESTQ <> 'S') BEGIN
         SET @V_CDLOCALESTOQ = ' ';
      END;

      EXECUTE CONSULTA_LOTE @V_IDUTILLOTE,@V_CDFILIMOVI,@V_CDALMOXARIFE,@V_CDLOCALESTOQ,@V_CDSUBPRODUTO,
                            @P_NRLOTEESTQ = @V_NRLOTEESTQ OUTPUT,@P_NRSUBLOTE  = @V_NRSUBLOTE  OUTPUT;

      SET @V_QTDEAUX = @P_QTITEMPROD * @V_QTSUBPRODROT;

      IF @V_PADRAO = 'S' BEGIN
         SELECT
            @V_EXISTE_PROD = COUNT(*)
         FROM ROTFABRICA
         WHERE CDPRODUTO = @V_CDSUBPRODUTO;
      END
      ELSE IF @V_PADRAO = 'N' BEGIN
         SELECT @V_EXISTE_PROD = COUNT(*)
         FROM ROTFABLOCAL
         WHERE CDFILIAL  = @V_CDFILIMOVI AND
               CDPRODUTO = @V_CDSUBPRODUTO;
      END;

      IF @V_EXISTE_PROD > 0  BEGIN

         EXECUTE INSERE_SUBPRODMAN @P_CDFILIAL    , @P_LANCESTQ  , @P_TIPOOPER  , @V_CDSUBPRODUTO,
                                @V_QTDEAUX     , @P_VRTOTAITEM, @P_VRDESCITEM, @P_VRBRUTITEM, @P_VRCONTITEM,
                                @P_VRTOTALANCTO, @P_QTDELANCTO, @P_TIPOMOVI  , @P_INIVALID  , @P_CDPRODESTO,
                                @P_NRPEDIDO, @P_NRITEMPED, @P_IDTPCOMPPROD, @V_CDALMOXARIFE, @V_CDLOCALESTOQ;
      END ELSE BEGIN
         /* BUSCAR O PREO DO CDSUBPRODUTO */

         SELECT @V_FATOCONV = MAX(VRFATOCONV), @V_CDPRODESTO = MAX(CDPRODESTO)
         FROM   PRODUTO
         WHERE  CDPRODUTO = @V_CDSUBPRODUTO;

         IF (@V_FATOCONV IS NULL) OR (@V_FATOCONV = 0)
         BEGIN
            SET @V_FATOCONV = 1;
         END;

         SET @V_QTDELANCTO   = @V_QTDEAUX;
         SET @V_VRTOTALANCTO = @P_VRTOTAITEM - @P_VRDESCITEM;

         IF NOT(@V_QTDELANCTO = 0) BEGIN
            SET @V_VRUNITLANCTO = @V_VRTOTALANCTO/@V_QTDELANCTO;
         END ELSE
            SET @V_VRUNITLANCTO = @V_VRTOTALANCTO;


         IF (@P_TIPOOPER = '06') BEGIN
            IF (@V_QTDELANCTO <> 0) BEGIN
               SET @V_TOTABRUT   = (@P_VRBRUTITEM/@V_QTDELANCTO)/@V_FATOCONV;
               SET @V_TOTACONTAB = (@P_VRCONTITEM/@V_QTDELANCTO)/@V_FATOCONV;
            END ELSE BEGIN
               SET @V_TOTABRUT   = @P_VRBRUTITEM/@V_FATOCONV;
               SET @V_TOTACONTAB = @P_VRCONTITEM/@V_FATOCONV;
            END;
         END ELSE BEGIN
            SET @V_TOTABRUT   = 0;
            SET @V_TOTACONTAB = 0;
         END;

         IF @V_CDALMOXARIFE IS NULL BEGIN
            SET @V_CDALMOXARIFE = ' ';
            SET @V_CDLOCALESTOQ = ' ';
            SET @V_NRLOTEESTQ   = ' ';
            SET @V_NRSUBLOTE    = ' ';
         END;

           /* TESTA SE EXISTE O PRODUTO NA ITLANCTOEST */
         SELECT @V_EXISTE_PRODUTO = COUNT(*)
         FROM   ITLANCTOEST
         WHERE  CDFILIAL   = @P_CDFILIAL
           AND  NRLANCESTQ = @P_LANCESTQ
           AND  CDPRODUTO  = @V_CDSUBPRODUTO;


         IF (@P_TIPOOPER <> '13') BEGIN


            SELECT @V_EXISTE_PROD = COUNT(*)
            FROM PAREXPEDICAO
            WHERE CDFILIAL = @V_CDFILIMOVI;

            IF @V_EXISTE_PROD >0 BEGIN
               SELECT @V_IDCUSEXP = IDCUSEXP
               FROM PAREXPEDICAO
               WHERE
                  CDFILIAL = @V_CDFILIMOVI;
            END
            ELSE BEGIN
               SET @V_IDCUSEXP = 0;
            END;

/* SE A COMPOSIO DO PRODUTO  VARIAVEL */
            IF @V_PADRAO = 'V' BEGIN
               SELECT @V_VRUNITITEM = VRPREUNICOMP
               FROM  COMPITEMPED
               WHERE
                  CDFILIAL  = @V_CDFILIMOVI AND
                  NRPEDIDO  = @P_NRPEDIDO AND
                  NRITEMPED = @P_NRITEMPED AND
                  CDPRODCOMPED = @V_CDSUBPRODUTO;
            END
            ELSE BEGIN
               SET @V_VRUNITITEM = TEKNISA.CUSTO_PROD (@V_CDFILIMOVI, @V_CDSUBPRODUTO, 5, @P_INIVALID, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
            END;

            /*  SE NAO EXISTIR O PRODUTO   */
            IF @V_EXISTE_PRODUTO = 0 BEGIN

               IF (@V_IDUTILLOTE = 'S') BEGIN

                     SET @V_QTDE = @V_QTDELANCTO;

                     DECLARE CUR_LOTE CURSOR FOR
                     (SELECT ISNULL(POSESTATU.NRLOTEESTQ, ' ') NRLOTEESTQ
                        FROM POSESTATU, LOTE
                       WHERE POSESTATU.CDFILIAL     = LOTE.CDFILIAL   AND
                             POSESTATU.NRLOTEESTQ   = LOTE.NRLOTEESTQ AND
                             POSESTATU.NRSUBLOTE    = LOTE.NRSUBLOTE  AND
                             POSESTATU.CDPRODUTO    = LOTE.CDPRODUTO  AND
                             POSESTATU.CDFILIAL     = @V_CDFILIMOVI    AND
                             POSESTATU.CDALMOXARIFE = @V_CDALMOXARIFE  AND
                             POSESTATU.CDLOCALESTOQ = @V_CDLOCALESTOQ  AND
                             POSESTATU.CDPRODUTO    = @V_CDSUBPRODUTO  AND
                             POSESTATU.QTTOTALESTOQ > 0               AND
                             LOTE.DTVALILOTE        > GETDATE()
                       ORDER BY LOTE.DTVALILOTE)

                     OPEN CUR_LOTE;
                     FETCH NEXT FROM CUR_LOTE INTO @V_NRLOTEESTQ;
                     WHILE @@FETCH_STATUS = 0 BEGIN

                        IF (CUR_LOTE.NRLOTEESTQ IS NULL) OR (CUR_LOTE.NRLOTEESTQ = '') OR (CUR_LOTE.NRLOTEESTQ = ' ') BEGIN
                           IF NOT (CUR_LOTE.NRLOTEESTQ = ' ') BEGIN
                              SET CUR_LOTE.NRLOTEESTQ = ' ';
                              SET @V_NRSUBLOTE         = ' ';
                           END;

                           SET @V_QTDEAUX = @V_QTDELANCTO;
                           SET @V_QTDE    = 0;
                        END
                        ELSE BEGIN
                           SELECT ISNULL(MAX(NRSUBLOTE), ' ')
                             INTO @V_NRSUBLOTE
                             FROM LOTE
                            WHERE (CDFILIAL   = @P_CDFILIAL) AND
                                  (NRLOTEESTQ = CUR_LOTE.NRLOTEESTQ);

                           EXECUTE POSICAO_ESTOQUE @V_CDFILIMOVI, @V_CDSUBPRODUTO, (GETDATE() + 1), @V_QTDEESTO = @V_QTDEESTO OUTPUT, @V_VALRESTO = @V_VALRESTO OUTPUT,
                               @V_VALRBRUT = @V_VALRBRUT OUTPUT, 'S', @V_CDALMOXARIFE, @V_CDLOCALESTOQ, NULL, NULL, NULL, CUR_LOTE.NRLOTEESTQ, @V_NRSUBLOTE;

                           IF (@V_QTDEESTO > @V_QTDE) OR (@V_QTDEESTO = @V_QTDE) BEGIN
                              SET @V_QTDEAUX = @V_QTDE;
                           END
                           ELSE BEGIN
                              SET @V_QTDEAUX = @V_QTDEESTO;
                           END;

                           SET @V_QTDE = @V_QTDE - @V_QTDEAUX;

                           IF (@V_QTDEAUX = 0) BEGIN
                              SET @V_QTDEAUX = @V_QTDELANCTO;
                           END;
                        END;

            /* SE A COMPOSIO DO PRODUTO  VARIAVEL */
                        IF @V_PADRAO = 'V' BEGIN
                           SELECT @V_VRUNITITEM = VRPREUNICOMP
                             FROM  COMPITEMPED
                            WHERE  CDFILIAL     = @V_CDFILIMOVI AND
                                   NRPEDIDO     = @P_NRPEDIDO   AND
                                   NRITEMPED    = @P_NRITEMPED  AND
                                   CDPRODCOMPED = @V_CDSUBPRODUTO;
                        END
                        ELSE BEGIN
                           SET @V_VRUNITITEM = TEKNISA.CUSTO_PROD (@V_CDFILIMOVI, @V_CDSUBPRODUTO, 5, @P_INIVALID, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
                        END;

                        SELECT @V_NRSEQITPROD = ISNULL(MAX(NRSEQUITEM),0) + 1
                        FROM ITLANCTOEST
                        WHERE CDFILIAL   = @P_CDFILIAL AND
                              NRLANCESTQ = @P_LANCESTQ;

                        INSERT INTO ITLANCTOEST
                           (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                            IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                            CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                        VALUES
                           (@P_CDFILIAL,@P_LANCESTQ,(RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),@V_CDSUBPRODUTO,
                            @V_QTDEAUX, @V_VRUNITITEM, (@V_VRUNITITEM * (@V_QTDEAUX * @V_FATOCONV)),
                            @P_TIPOMOVI,@P_INIVALID,'8',@V_CDPRODESTO,
                            (@V_QTDEAUX * @V_FATOCONV), (@V_VRUNITITEM * (@V_QTDEAUX * @V_FATOCONV)), (@V_VRUNITITEM * (@V_QTDEAUX * @V_FATOCONV)),
                            @V_CDFILIMOVI, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, CUR_LOTE.NRLOTEESTQ, @V_NRSUBLOTE);

                        IF (@V_QTDE = 0) BEGIN
                           EXIT;
                        END;

                        FETCH NEXT FROM CUR_LOTE INTO @V_NRLOTEESTQ;
                     END;
                     CLOSE CUR_LOTE;
                     DEALLOCATE CUR_LOTE;
               END
               ELSE BEGIN
                  SET @V_NRLOTEESTQ = ' ';
                  SET @V_NRSUBLOTE  = ' ';

                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                     IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                     VRCUSTENTR,CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                  VALUES
                     (@P_CDFILIAL,@P_LANCESTQ,(RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),@V_CDSUBPRODUTO,
                     @V_QTDELANCTO,0,0,
                     @P_TIPOMOVI,@P_INIVALID,'8',@V_CDPRODESTO,
                     (@V_QTDELANCTO * @V_FATOCONV), @V_TOTABRUT, @V_TOTACONTAB, @V_VRCUSTENTR,
                     @V_CDFILIMOVI, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
               END;
            END ELSE BEGIN
               UPDATE ITLANCTOEST
               SET    QTTOTLANCTO  = QTTOTLANCTO  +  @V_QTDELANCTO,
                      QTLANCTOEST  = QTLANCTOEST  + (@V_QTDELANCTO * @V_FATOCONV),
                      VRTOTLANCTO  = VRTOTLANCTO  + (@V_VRUNITITEM * (@V_QTDELANCTO * @V_FATOCONV)),
                      VRLANCTOBRUT = VRLANCTOBRUT + (@V_VRUNITITEM * (@V_QTDELANCTO * @V_FATOCONV)),
                      VRLANCTOEST  = VRLANCTOEST  + (@V_VRUNITITEM * (@V_QTDELANCTO * @V_FATOCONV))
               WHERE  CDFILIAL   = @P_CDFILIAL
                 AND  NRLANCESTQ = @P_LANCESTQ
                 AND  CDPRODUTO  = @V_CDSUBPRODUTO;

            END;
         END ELSE IF (@P_TIPOOPER <> '06') OR ((@P_TIPOOPER = '06') AND (@V_QTDELANCTO <> 0)) BEGIN

            IF (@P_TIPOOPER = '13') BEGIN
               SELECT @V_VRCUSTENTR = TEKNISA.CUSTO_PROD (@P_CDFILIAL,@V_CDSUBPRODUTO,6,@P_INIVALID,
                                                          @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                                          @V_NRSUBLOTE)
               FROM PARAMGERAL;

               SET @V_TOTACONTAB = @V_VRCUSTENTR;
               SELECT @V_TOTABRUT = TEKNISA.CUSTO_PROD (@P_CDFILIAL,@V_CDSUBPRODUTO,9,@P_INIVALID,
                                                        @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                                        @V_NRSUBLOTE)
               FROM PARAMGERAL;

            END ELSE BEGIN
               SET @V_VRCUSTENTR = 0;
               SET @V_TOTACONTAB = 0;
               SET @V_TOTABRUT   = 0;
            END;

            /*  SE NAO EXISTIR O PRODUTO   */
            IF @V_EXISTE_PRODUTO = 0 BEGIN

               IF (@V_IDUTILLOTE = 'S') BEGIN

                  SET @V_QTDE = @V_QTDELANCTO;

                  DECLARE CUR_LOTE CURSOR FOR
                  (SELECT ISNULL(POSESTATU.NRLOTEESTQ, ' ') NRLOTEESTQ
                     FROM POSESTATU, LOTE
                    WHERE POSESTATU.CDFILIAL     = LOTE.CDFILIAL   AND
                          POSESTATU.NRLOTEESTQ   = LOTE.NRLOTEESTQ AND
                          POSESTATU.NRSUBLOTE    = LOTE.NRSUBLOTE  AND
                          POSESTATU.CDPRODUTO    = LOTE.CDPRODUTO  AND
                          POSESTATU.CDFILIAL     = @V_CDFILIMOVI    AND
                          POSESTATU.CDALMOXARIFE = @V_CDALMOXARIFE  AND
                          POSESTATU.CDLOCALESTOQ = @V_CDLOCALESTOQ  AND
                          POSESTATU.CDPRODUTO    = @V_CDSUBPRODUTO  AND
                          POSESTATU.QTTOTALESTOQ > 0               AND
                          LOTE.DTVALILOTE        > GETDATE()
                    ORDER BY LOTE.DTVALILOTE)

                  OPEN CUR_LOTE;
                  FETCH NEXT FROM CUR_LOTE INTO @V_NRLOTEESTQ;
                  WHILE @@FETCH_STATUS = 0 BEGIN

                     IF (CUR_LOTE.NRLOTEESTQ IS NULL) OR (CUR_LOTE.NRLOTEESTQ = '') OR (CUR_LOTE.NRLOTEESTQ = ' ') BEGIN
                        IF NOT (CUR_LOTE.NRLOTEESTQ = ' ') BEGIN
                           SET CUR_LOTE.NRLOTEESTQ = ' ';
                           SET @V_NRSUBLOTE         = ' ';
                        END;

                        SET @V_QTDEAUX = @V_QTDELANCTO;
                        SET @V_QTDE    = 0;
                     END
                     ELSE BEGIN
                        SELECT ISNULL(MAX(NRSUBLOTE), ' ')
                          INTO @V_NRSUBLOTE
                          FROM LOTE
                         WHERE (CDFILIAL   = @P_CDFILIAL) AND
                               (NRLOTEESTQ = CUR_LOTE.NRLOTEESTQ);

                        EXECUTE POSICAO_ESTOQUE @V_CDFILIMOVI, @V_CDSUBPRODUTO, (GETDATE() + 1), @V_QTDEESTO = @V_QTDEESTO OUTPUT, @V_VALRESTO = @V_VALRESTO OUTPUT,
                            @V_VALRBRUT = @V_VALRBRUT OUTPUT, 'S', @V_CDALMOXARIFE, @V_CDLOCALESTOQ, NULL, NULL, NULL, CUR_LOTE.NRLOTEESTQ, @V_NRSUBLOTE;

                        IF (@V_QTDEESTO > @V_QTDE) OR (@V_QTDEESTO = @V_QTDE) BEGIN
                           SET @V_QTDEAUX = @V_QTDE;
                        END
                        ELSE BEGIN
                           SET @V_QTDEAUX = @V_QTDEESTO;
                        END;

                        SET @V_QTDE = @V_QTDE - @V_QTDEAUX;

                        IF (@V_QTDEAUX = 0) BEGIN
                           SET @V_QTDEAUX = @V_QTDELANCTO;
                        END;
                     END;

                     IF (@P_TIPOOPER = '13') BEGIN
                        SELECT @V_VRCUSTENTR = TEKNISA.CUSTO_PROD (@P_CDFILIAL,@V_CDSUBPRODUTO,6,@P_INIVALID,
                                                                   @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                                                   @V_NRSUBLOTE)
                        FROM PARAMGERAL;

                        SET @V_TOTACONTAB = @V_VRCUSTENTR;
                        SELECT @V_TOTABRUT = TEKNISA.CUSTO_PROD (@P_CDFILIAL,@V_CDSUBPRODUTO,9,@P_INIVALID,
                                                                 @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,
                                                                 @V_NRSUBLOTE)
                     FROM PARAMGERAL;

                     END ELSE BEGIN
                        SET @V_VRCUSTENTR = 0;
                        SET @V_TOTACONTAB = 0;
                        SET @V_TOTABRUT   = 0;
                     END;

                     SELECT @V_NRSEQITPROD = ISNULL(MAX(NRSEQUITEM),0) + 1
                     FROM   ITLANCTOEST
                     WHERE  CDFILIAL   = @P_CDFILIAL AND
                            NRLANCESTQ = @P_LANCESTQ;

                     INSERT INTO ITLANCTOEST
                        (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                         IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                         VRCUSTENTR,CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                     VALUES
                        (@P_CDFILIAL,@P_LANCESTQ,(RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),@V_CDSUBPRODUTO,
                         @V_QTDEAUX,0,0,
                         @P_TIPOMOVI,@P_INIVALID,'8',@V_CDPRODESTO,
                         (@V_QTDEAUX * @V_FATOCONV), @V_TOTABRUT, @V_TOTACONTAB, @V_VRCUSTENTR,
                         @V_CDFILIMOVI, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);

                     IF (@V_QTDE = 0) BEGIN
                        EXIT;
                     END;

                     FETCH NEXT FROM CUR_LOTE INTO @V_NRLOTEESTQ;
                  END;
                  CLOSE CUR_LOTE;
                  DEALLOCATE CUR_LOTE;
               END
               ELSE BEGIN
                  SET @V_NRLOTEESTQ = ' ';
                  SET @V_NRSUBLOTE  = ' ';

                  INSERT INTO ITLANCTOEST
                     (CDFILIAL,NRLANCESTQ,NRSEQUITEM,CDPRODUTO,QTTOTLANCTO,VRUNILANCTO,VRTOTLANCTO,
                      IDTIPOMOVI,DTLANCMOVI,IDORDEMCLC,CDPRODMOVI,QTLANCTOEST,VRLANCTOBRUT, VRLANCTOEST,
                      VRCUSTENTR,CDFILIMOVI, CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE)
                  VALUES
                     (@P_CDFILIAL,@P_LANCESTQ,(RIGHT('0000',4 - DATALENGTH(CONVERT(VARCHAR,@V_NRSEQITPROD))) + CONVERT(VARCHAR,@V_NRSEQITPROD)),@V_CDSUBPRODUTO,
                      @V_QTDELANCTO,0,0,
                      @P_TIPOMOVI,@P_INIVALID,'8',@V_CDPRODESTO,
                      (@V_QTDELANCTO * @V_FATOCONV), @V_TOTABRUT, @V_TOTACONTAB, @V_VRCUSTENTR,
                      @V_CDFILIMOVI, @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ, @V_NRSUBLOTE);
               END;
            END ELSE BEGIN
               UPDATE ITLANCTOEST
               SET    QTTOTLANCTO = (QTTOTLANCTO + @V_QTDELANCTO),
                      QTLANCTOEST = (QTLANCTOEST + (@V_QTDELANCTO * @V_FATOCONV)),
                      VRTOTLANCTO = VRTOTLANCTO + @V_VRTOTALANCTO
               WHERE  CDFILIAL   = @P_CDFILIAL
                 AND  NRLANCESTQ = @P_LANCESTQ
                 AND  CDPRODUTO  = @V_CDSUBPRODUTO;
            END;
         END;
      END;
      FETCH NEXT FROM CUR_ROTFAB INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT
   END;
   CLOSE CUR_ROTFAB;
   DEALLOCATE CUR_ROTFAB;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'INSERE_SUBPRODMAN','5.01.012';
GO

